Merge branch 'fr/rebase-i-continue-preserve-options'
[git/git.git] / git-rebase--interactive.sh
1 # This shell script fragment is sourced by git-rebase to implement
2 # its interactive mode. "git rebase --interactive" makes it easy
3 # to fix up commits in the middle of a series and rearrange commits.
4 #
5 # Copyright (c) 2006 Johannes E. Schindelin
6 #
7 # The original idea comes from Eric W. Biederman, in
8 # http://article.gmane.org/gmane.comp.version-control.git/22407
9 #
10 # The file containing rebase commands, comments, and empty lines.
11 # This file is created by "git rebase -i" then edited by the user. As
12 # the lines are processed, they are removed from the front of this
13 # file and written to the tail of $done.
14 todo="$state_dir"/git-rebase-todo
15
16 # The rebase command lines that have already been processed. A line
17 # is moved here when it is first handled, before any associated user
18 # actions.
19 done="$state_dir"/done
20
21 # The commit message that is planned to be used for any changes that
22 # need to be committed following a user interaction.
23 msg="$state_dir"/message
24
25 # The file into which is accumulated the suggested commit message for
26 # squash/fixup commands. When the first of a series of squash/fixups
27 # is seen, the file is created and the commit message from the
28 # previous commit and from the first squash/fixup commit are written
29 # to it. The commit message for each subsequent squash/fixup commit
30 # is appended to the file as it is processed.
31 #
32 # The first line of the file is of the form
33 # # This is a combination of $count commits.
34 # where $count is the number of commits whose messages have been
35 # written to the file so far (including the initial "pick" commit).
36 # Each time that a commit message is processed, this line is read and
37 # updated. It is deleted just before the combined commit is made.
38 squash_msg="$state_dir"/message-squash
39
40 # If the current series of squash/fixups has not yet included a squash
41 # command, then this file exists and holds the commit message of the
42 # original "pick" commit. (If the series ends without a "squash"
43 # command, then this can be used as the commit message of the combined
44 # commit without opening the editor.)
45 fixup_msg="$state_dir"/message-fixup
46
47 # $rewritten is the name of a directory containing files for each
48 # commit that is reachable by at least one merge base of $head and
49 # $upstream. They are not necessarily rewritten, but their children
50 # might be. This ensures that commits on merged, but otherwise
51 # unrelated side branches are left alone. (Think "X" in the man page's
52 # example.)
53 rewritten="$state_dir"/rewritten
54
55 dropped="$state_dir"/dropped
56
57 end="$state_dir"/end
58 msgnum="$state_dir"/msgnum
59
60 # A script to set the GIT_AUTHOR_NAME, GIT_AUTHOR_EMAIL, and
61 # GIT_AUTHOR_DATE that will be used for the commit that is currently
62 # being rebased.
63 author_script="$state_dir"/author-script
64
65 # When an "edit" rebase command is being processed, the SHA1 of the
66 # commit to be edited is recorded in this file. When "git rebase
67 # --continue" is executed, if there are any staged changes then they
68 # will be amended to the HEAD commit, but only provided the HEAD
69 # commit is still the commit to be edited. When any other rebase
70 # command is processed, this file is deleted.
71 amend="$state_dir"/amend
72
73 # For the post-rewrite hook, we make a list of rewritten commits and
74 # their new sha1s. The rewritten-pending list keeps the sha1s of
75 # commits that have been processed, but not committed yet,
76 # e.g. because they are waiting for a 'squash' command.
77 rewritten_list="$state_dir"/rewritten-list
78 rewritten_pending="$state_dir"/rewritten-pending
79
80 # Work around Git for Windows' Bash whose "read" does not strip CRLF
81 # and leaves CR at the end instead.
82 cr=$(printf "\015")
83
84 strategy_args=${strategy:+--strategy=$strategy}
85 eval '
86 for strategy_opt in '"$strategy_opts"'
87 do
88 strategy_args="$strategy_args -X$(git rev-parse --sq-quote "${strategy_opt#--}")"
89 done
90 '
91
92 GIT_CHERRY_PICK_HELP="$resolvemsg"
93 export GIT_CHERRY_PICK_HELP
94
95 comment_char=$(git config --get core.commentchar 2>/dev/null | cut -c1)
96 : ${comment_char:=#}
97
98 warn () {
99 printf '%s\n' "$*" >&2
100 }
101
102 # Output the commit message for the specified commit.
103 commit_message () {
104 git cat-file commit "$1" | sed "1,/^$/d"
105 }
106
107 orig_reflog_action="$GIT_REFLOG_ACTION"
108
109 comment_for_reflog () {
110 case "$orig_reflog_action" in
111 ''|rebase*)
112 GIT_REFLOG_ACTION="rebase -i ($1)"
113 export GIT_REFLOG_ACTION
114 ;;
115 esac
116 }
117
118 last_count=
119 mark_action_done () {
120 sed -e 1q < "$todo" >> "$done"
121 sed -e 1d < "$todo" >> "$todo".new
122 mv -f "$todo".new "$todo"
123 new_count=$(git stripspace --strip-comments <"$done" | wc -l)
124 echo $new_count >"$msgnum"
125 total=$(($new_count + $(git stripspace --strip-comments <"$todo" | wc -l)))
126 echo $total >"$end"
127 if test "$last_count" != "$new_count"
128 then
129 last_count=$new_count
130 printf "Rebasing (%d/%d)\r" $new_count $total
131 test -z "$verbose" || echo
132 fi
133 }
134
135 # Put the last action marked done at the beginning of the todo list
136 # again. If there has not been an action marked done yet, leave the list of
137 # items on the todo list unchanged.
138 reschedule_last_action () {
139 tail -n 1 "$done" | cat - "$todo" >"$todo".new
140 sed -e \$d <"$done" >"$done".new
141 mv -f "$todo".new "$todo"
142 mv -f "$done".new "$done"
143 }
144
145 append_todo_help () {
146 git stripspace --comment-lines >>"$todo" <<\EOF
147
148 Commands:
149 p, pick = use commit
150 r, reword = use commit, but edit the commit message
151 e, edit = use commit, but stop for amending
152 s, squash = use commit, but meld into previous commit
153 f, fixup = like "squash", but discard this commit's log message
154 x, exec = run command (the rest of the line) using shell
155 d, drop = remove commit
156
157 These lines can be re-ordered; they are executed from top to bottom.
158
159 EOF
160 if test $(get_missing_commit_check_level) = error
161 then
162 git stripspace --comment-lines >>"$todo" <<\EOF
163 Do not remove any line. Use 'drop' explicitly to remove a commit.
164 EOF
165 else
166 git stripspace --comment-lines >>"$todo" <<\EOF
167 If you remove a line here THAT COMMIT WILL BE LOST.
168 EOF
169 fi
170 }
171
172 make_patch () {
173 sha1_and_parents="$(git rev-list --parents -1 "$1")"
174 case "$sha1_and_parents" in
175 ?*' '?*' '?*)
176 git diff --cc $sha1_and_parents
177 ;;
178 ?*' '?*)
179 git diff-tree -p "$1^!"
180 ;;
181 *)
182 echo "Root commit"
183 ;;
184 esac > "$state_dir"/patch
185 test -f "$msg" ||
186 commit_message "$1" > "$msg"
187 test -f "$author_script" ||
188 get_author_ident_from_commit "$1" > "$author_script"
189 }
190
191 die_with_patch () {
192 echo "$1" > "$state_dir"/stopped-sha
193 make_patch "$1"
194 git rerere
195 die "$2"
196 }
197
198 exit_with_patch () {
199 echo "$1" > "$state_dir"/stopped-sha
200 make_patch $1
201 git rev-parse --verify HEAD > "$amend"
202 gpg_sign_opt_quoted=${gpg_sign_opt:+$(git rev-parse --sq-quote "$gpg_sign_opt")}
203 warn "You can amend the commit now, with"
204 warn
205 warn " git commit --amend $gpg_sign_opt_quoted"
206 warn
207 warn "Once you are satisfied with your changes, run"
208 warn
209 warn " git rebase --continue"
210 warn
211 exit $2
212 }
213
214 die_abort () {
215 rm -rf "$state_dir"
216 die "$1"
217 }
218
219 has_action () {
220 test -n "$(git stripspace --strip-comments <"$1")"
221 }
222
223 is_empty_commit() {
224 tree=$(git rev-parse -q --verify "$1"^{tree} 2>/dev/null ||
225 die "$1: not a commit that can be picked")
226 ptree=$(git rev-parse -q --verify "$1"^^{tree} 2>/dev/null ||
227 ptree=4b825dc642cb6eb9a060e54bf8d69288fbee4904)
228 test "$tree" = "$ptree"
229 }
230
231 is_merge_commit()
232 {
233 git rev-parse --verify --quiet "$1"^2 >/dev/null 2>&1
234 }
235
236 # Run command with GIT_AUTHOR_NAME, GIT_AUTHOR_EMAIL, and
237 # GIT_AUTHOR_DATE exported from the current environment.
238 do_with_author () {
239 (
240 export GIT_AUTHOR_NAME GIT_AUTHOR_EMAIL GIT_AUTHOR_DATE
241 "$@"
242 )
243 }
244
245 git_sequence_editor () {
246 if test -z "$GIT_SEQUENCE_EDITOR"
247 then
248 GIT_SEQUENCE_EDITOR="$(git config sequence.editor)"
249 if [ -z "$GIT_SEQUENCE_EDITOR" ]
250 then
251 GIT_SEQUENCE_EDITOR="$(git var GIT_EDITOR)" || return $?
252 fi
253 fi
254
255 eval "$GIT_SEQUENCE_EDITOR" '"$@"'
256 }
257
258 pick_one () {
259 ff=--ff
260
261 case "$1" in -n) sha1=$2; ff= ;; *) sha1=$1 ;; esac
262 case "$force_rebase" in '') ;; ?*) ff= ;; esac
263 output git rev-parse --verify $sha1 || die "Invalid commit name: $sha1"
264
265 if is_empty_commit "$sha1"
266 then
267 empty_args="--allow-empty"
268 fi
269
270 test -d "$rewritten" &&
271 pick_one_preserving_merges "$@" && return
272 output eval git cherry-pick \
273 ${gpg_sign_opt:+$(git rev-parse --sq-quote "$gpg_sign_opt")} \
274 "$strategy_args" $empty_args $ff "$@"
275
276 # If cherry-pick dies it leaves the to-be-picked commit unrecorded. Reschedule
277 # previous task so this commit is not lost.
278 ret=$?
279 case "$ret" in [01]) ;; *) reschedule_last_action ;; esac
280 return $ret
281 }
282
283 pick_one_preserving_merges () {
284 fast_forward=t
285 case "$1" in
286 -n)
287 fast_forward=f
288 sha1=$2
289 ;;
290 *)
291 sha1=$1
292 ;;
293 esac
294 sha1=$(git rev-parse $sha1)
295
296 if test -f "$state_dir"/current-commit
297 then
298 if test "$fast_forward" = t
299 then
300 while read current_commit
301 do
302 git rev-parse HEAD > "$rewritten"/$current_commit
303 done <"$state_dir"/current-commit
304 rm "$state_dir"/current-commit ||
305 die "Cannot write current commit's replacement sha1"
306 fi
307 fi
308
309 echo $sha1 >> "$state_dir"/current-commit
310
311 # rewrite parents; if none were rewritten, we can fast-forward.
312 new_parents=
313 pend=" $(git rev-list --parents -1 $sha1 | cut -d' ' -s -f2-)"
314 if test "$pend" = " "
315 then
316 pend=" root"
317 fi
318 while [ "$pend" != "" ]
319 do
320 p=$(expr "$pend" : ' \([^ ]*\)')
321 pend="${pend# $p}"
322
323 if test -f "$rewritten"/$p
324 then
325 new_p=$(cat "$rewritten"/$p)
326
327 # If the todo reordered commits, and our parent is marked for
328 # rewriting, but hasn't been gotten to yet, assume the user meant to
329 # drop it on top of the current HEAD
330 if test -z "$new_p"
331 then
332 new_p=$(git rev-parse HEAD)
333 fi
334
335 test $p != $new_p && fast_forward=f
336 case "$new_parents" in
337 *$new_p*)
338 ;; # do nothing; that parent is already there
339 *)
340 new_parents="$new_parents $new_p"
341 ;;
342 esac
343 else
344 if test -f "$dropped"/$p
345 then
346 fast_forward=f
347 replacement="$(cat "$dropped"/$p)"
348 test -z "$replacement" && replacement=root
349 pend=" $replacement$pend"
350 else
351 new_parents="$new_parents $p"
352 fi
353 fi
354 done
355 case $fast_forward in
356 t)
357 output warn "Fast-forward to $sha1"
358 output git reset --hard $sha1 ||
359 die "Cannot fast-forward to $sha1"
360 ;;
361 f)
362 first_parent=$(expr "$new_parents" : ' \([^ ]*\)')
363
364 if [ "$1" != "-n" ]
365 then
366 # detach HEAD to current parent
367 output git checkout $first_parent 2> /dev/null ||
368 die "Cannot move HEAD to $first_parent"
369 fi
370
371 case "$new_parents" in
372 ' '*' '*)
373 test "a$1" = a-n && die "Refusing to squash a merge: $sha1"
374
375 # redo merge
376 author_script_content=$(get_author_ident_from_commit $sha1)
377 eval "$author_script_content"
378 msg_content="$(commit_message $sha1)"
379 # No point in merging the first parent, that's HEAD
380 new_parents=${new_parents# $first_parent}
381 merge_args="--no-log --no-ff"
382 if ! do_with_author output eval \
383 'git merge ${gpg_sign_opt:+"$gpg_sign_opt"} \
384 $merge_args $strategy_args -m "$msg_content" $new_parents'
385 then
386 printf "%s\n" "$msg_content" > "$GIT_DIR"/MERGE_MSG
387 die_with_patch $sha1 "Error redoing merge $sha1"
388 fi
389 echo "$sha1 $(git rev-parse HEAD^0)" >> "$rewritten_list"
390 ;;
391 *)
392 output eval git cherry-pick \
393 ${gpg_sign_opt:+$(git rev-parse --sq-quote "$gpg_sign_opt")} \
394 "$strategy_args" "$@" ||
395 die_with_patch $sha1 "Could not pick $sha1"
396 ;;
397 esac
398 ;;
399 esac
400 }
401
402 nth_string () {
403 case "$1" in
404 *1[0-9]|*[04-9]) echo "$1"th;;
405 *1) echo "$1"st;;
406 *2) echo "$1"nd;;
407 *3) echo "$1"rd;;
408 esac
409 }
410
411 update_squash_messages () {
412 if test -f "$squash_msg"; then
413 mv "$squash_msg" "$squash_msg".bak || exit
414 count=$(($(sed -n \
415 -e "1s/^. This is a combination of \(.*\) commits\./\1/p" \
416 -e "q" < "$squash_msg".bak)+1))
417 {
418 printf '%s\n' "$comment_char This is a combination of $count commits."
419 sed -e 1d -e '2,/^./{
420 /^$/d
421 }' <"$squash_msg".bak
422 } >"$squash_msg"
423 else
424 commit_message HEAD > "$fixup_msg" || die "Cannot write $fixup_msg"
425 count=2
426 {
427 printf '%s\n' "$comment_char This is a combination of 2 commits."
428 printf '%s\n' "$comment_char The first commit's message is:"
429 echo
430 cat "$fixup_msg"
431 } >"$squash_msg"
432 fi
433 case $1 in
434 squash)
435 rm -f "$fixup_msg"
436 echo
437 printf '%s\n' "$comment_char This is the $(nth_string $count) commit message:"
438 echo
439 commit_message $2
440 ;;
441 fixup)
442 echo
443 printf '%s\n' "$comment_char The $(nth_string $count) commit message will be skipped:"
444 echo
445 # Change the space after the comment character to TAB:
446 commit_message $2 | git stripspace --comment-lines | sed -e 's/ / /'
447 ;;
448 esac >>"$squash_msg"
449 }
450
451 peek_next_command () {
452 git stripspace --strip-comments <"$todo" | sed -n -e 's/ .*//p' -e q
453 }
454
455 # A squash/fixup has failed. Prepare the long version of the squash
456 # commit message, then die_with_patch. This code path requires the
457 # user to edit the combined commit message for all commits that have
458 # been squashed/fixedup so far. So also erase the old squash
459 # messages, effectively causing the combined commit to be used as the
460 # new basis for any further squash/fixups. Args: sha1 rest
461 die_failed_squash() {
462 mv "$squash_msg" "$msg" || exit
463 rm -f "$fixup_msg"
464 cp "$msg" "$GIT_DIR"/MERGE_MSG || exit
465 warn
466 warn "Could not apply $1... $2"
467 die_with_patch $1 ""
468 }
469
470 flush_rewritten_pending() {
471 test -s "$rewritten_pending" || return
472 newsha1="$(git rev-parse HEAD^0)"
473 sed "s/$/ $newsha1/" < "$rewritten_pending" >> "$rewritten_list"
474 rm -f "$rewritten_pending"
475 }
476
477 record_in_rewritten() {
478 oldsha1="$(git rev-parse $1)"
479 echo "$oldsha1" >> "$rewritten_pending"
480
481 case "$(peek_next_command)" in
482 squash|s|fixup|f)
483 ;;
484 *)
485 flush_rewritten_pending
486 ;;
487 esac
488 }
489
490 do_pick () {
491 if test "$(git rev-parse HEAD)" = "$squash_onto"
492 then
493 # Set the correct commit message and author info on the
494 # sentinel root before cherry-picking the original changes
495 # without committing (-n). Finally, update the sentinel again
496 # to include these changes. If the cherry-pick results in a
497 # conflict, this means our behaviour is similar to a standard
498 # failed cherry-pick during rebase, with a dirty index to
499 # resolve before manually running git commit --amend then git
500 # rebase --continue.
501 git commit --allow-empty --allow-empty-message --amend \
502 --no-post-rewrite -n -q -C $1 &&
503 pick_one -n $1 &&
504 git commit --allow-empty --allow-empty-message \
505 --amend --no-post-rewrite -n -q -C $1 \
506 ${gpg_sign_opt:+"$gpg_sign_opt"} ||
507 die_with_patch $1 "Could not apply $1... $2"
508 else
509 pick_one $1 ||
510 die_with_patch $1 "Could not apply $1... $2"
511 fi
512 }
513
514 do_next () {
515 rm -f "$msg" "$author_script" "$amend" "$state_dir"/stopped-sha || exit
516 read -r command sha1 rest < "$todo"
517 case "$command" in
518 "$comment_char"*|''|noop|drop|d)
519 mark_action_done
520 ;;
521 "$cr")
522 # Work around CR left by "read" (e.g. with Git for Windows' Bash).
523 mark_action_done
524 ;;
525 pick|p)
526 comment_for_reflog pick
527
528 mark_action_done
529 do_pick $sha1 "$rest"
530 record_in_rewritten $sha1
531 ;;
532 reword|r)
533 comment_for_reflog reword
534
535 mark_action_done
536 do_pick $sha1 "$rest"
537 git commit --amend --no-post-rewrite ${gpg_sign_opt:+"$gpg_sign_opt"} || {
538 warn "Could not amend commit after successfully picking $sha1... $rest"
539 warn "This is most likely due to an empty commit message, or the pre-commit hook"
540 warn "failed. If the pre-commit hook failed, you may need to resolve the issue before"
541 warn "you are able to reword the commit."
542 exit_with_patch $sha1 1
543 }
544 record_in_rewritten $sha1
545 ;;
546 edit|e)
547 comment_for_reflog edit
548
549 mark_action_done
550 do_pick $sha1 "$rest"
551 warn "Stopped at $sha1... $rest"
552 exit_with_patch $sha1 0
553 ;;
554 squash|s|fixup|f)
555 case "$command" in
556 squash|s)
557 squash_style=squash
558 ;;
559 fixup|f)
560 squash_style=fixup
561 ;;
562 esac
563 comment_for_reflog $squash_style
564
565 test -f "$done" && has_action "$done" ||
566 die "Cannot '$squash_style' without a previous commit"
567
568 mark_action_done
569 update_squash_messages $squash_style $sha1
570 author_script_content=$(get_author_ident_from_commit HEAD)
571 echo "$author_script_content" > "$author_script"
572 eval "$author_script_content"
573 if ! pick_one -n $sha1
574 then
575 git rev-parse --verify HEAD >"$amend"
576 die_failed_squash $sha1 "$rest"
577 fi
578 case "$(peek_next_command)" in
579 squash|s|fixup|f)
580 # This is an intermediate commit; its message will only be
581 # used in case of trouble. So use the long version:
582 do_with_author output git commit --amend --no-verify -F "$squash_msg" \
583 ${gpg_sign_opt:+"$gpg_sign_opt"} ||
584 die_failed_squash $sha1 "$rest"
585 ;;
586 *)
587 # This is the final command of this squash/fixup group
588 if test -f "$fixup_msg"
589 then
590 do_with_author git commit --amend --no-verify -F "$fixup_msg" \
591 ${gpg_sign_opt:+"$gpg_sign_opt"} ||
592 die_failed_squash $sha1 "$rest"
593 else
594 cp "$squash_msg" "$GIT_DIR"/SQUASH_MSG || exit
595 rm -f "$GIT_DIR"/MERGE_MSG
596 do_with_author git commit --amend --no-verify -F "$GIT_DIR"/SQUASH_MSG -e \
597 ${gpg_sign_opt:+"$gpg_sign_opt"} ||
598 die_failed_squash $sha1 "$rest"
599 fi
600 rm -f "$squash_msg" "$fixup_msg"
601 ;;
602 esac
603 record_in_rewritten $sha1
604 ;;
605 x|"exec")
606 read -r command rest < "$todo"
607 mark_action_done
608 printf 'Executing: %s\n' "$rest"
609 "${SHELL:-@SHELL_PATH@}" -c "$rest" # Actual execution
610 status=$?
611 # Run in subshell because require_clean_work_tree can die.
612 dirty=f
613 (require_clean_work_tree "rebase" 2>/dev/null) || dirty=t
614 if test "$status" -ne 0
615 then
616 warn "Execution failed: $rest"
617 test "$dirty" = f ||
618 warn "and made changes to the index and/or the working tree"
619
620 warn "You can fix the problem, and then run"
621 warn
622 warn " git rebase --continue"
623 warn
624 if test $status -eq 127 # command not found
625 then
626 status=1
627 fi
628 exit "$status"
629 elif test "$dirty" = t
630 then
631 warn "Execution succeeded: $rest"
632 warn "but left changes to the index and/or the working tree"
633 warn "Commit or stash your changes, and then run"
634 warn
635 warn " git rebase --continue"
636 warn
637 exit 1
638 fi
639 ;;
640 *)
641 warn "Unknown command: $command $sha1 $rest"
642 fixtodo="Please fix this using 'git rebase --edit-todo'."
643 if git rev-parse --verify -q "$sha1" >/dev/null
644 then
645 die_with_patch $sha1 "$fixtodo"
646 else
647 die "$fixtodo"
648 fi
649 ;;
650 esac
651 test -s "$todo" && return
652
653 comment_for_reflog finish &&
654 newhead=$(git rev-parse HEAD) &&
655 case $head_name in
656 refs/*)
657 message="$GIT_REFLOG_ACTION: $head_name onto $onto" &&
658 git update-ref -m "$message" $head_name $newhead $orig_head &&
659 git symbolic-ref \
660 -m "$GIT_REFLOG_ACTION: returning to $head_name" \
661 HEAD $head_name
662 ;;
663 esac && {
664 test ! -f "$state_dir"/verbose ||
665 git diff-tree --stat $orig_head..HEAD
666 } &&
667 {
668 test -s "$rewritten_list" &&
669 git notes copy --for-rewrite=rebase < "$rewritten_list" ||
670 true # we don't care if this copying failed
671 } &&
672 hook="$(git rev-parse --git-path hooks/post-rewrite)"
673 if test -x "$hook" && test -s "$rewritten_list"; then
674 "$hook" rebase < "$rewritten_list"
675 true # we don't care if this hook failed
676 fi &&
677 warn "Successfully rebased and updated $head_name."
678
679 return 1 # not failure; just to break the do_rest loop
680 }
681
682 # can only return 0, when the infinite loop breaks
683 do_rest () {
684 while :
685 do
686 do_next || break
687 done
688 }
689
690 # skip picking commits whose parents are unchanged
691 skip_unnecessary_picks () {
692 fd=3
693 while read -r command rest
694 do
695 # fd=3 means we skip the command
696 case "$fd,$command" in
697 3,pick|3,p)
698 # pick a commit whose parent is current $onto -> skip
699 sha1=${rest%% *}
700 case "$(git rev-parse --verify --quiet "$sha1"^)" in
701 "$onto"*)
702 onto=$sha1
703 ;;
704 *)
705 fd=1
706 ;;
707 esac
708 ;;
709 3,"$comment_char"*|3,)
710 # copy comments
711 ;;
712 *)
713 fd=1
714 ;;
715 esac
716 printf '%s\n' "$command${rest:+ }$rest" >&$fd
717 done <"$todo" >"$todo.new" 3>>"$done" &&
718 mv -f "$todo".new "$todo" &&
719 case "$(peek_next_command)" in
720 squash|s|fixup|f)
721 record_in_rewritten "$onto"
722 ;;
723 esac ||
724 die "Could not skip unnecessary pick commands"
725 }
726
727 transform_todo_ids () {
728 while read -r command rest
729 do
730 case "$command" in
731 "$comment_char"* | exec)
732 # Be careful for oddball commands like 'exec'
733 # that do not have a SHA-1 at the beginning of $rest.
734 ;;
735 *)
736 sha1=$(git rev-parse --verify --quiet "$@" ${rest%%[ ]*}) &&
737 rest="$sha1 ${rest#*[ ]}"
738 ;;
739 esac
740 printf '%s\n' "$command${rest:+ }$rest"
741 done <"$todo" >"$todo.new" &&
742 mv -f "$todo.new" "$todo"
743 }
744
745 expand_todo_ids() {
746 transform_todo_ids
747 }
748
749 collapse_todo_ids() {
750 transform_todo_ids --short
751 }
752
753 # Rearrange the todo list that has both "pick sha1 msg" and
754 # "pick sha1 fixup!/squash! msg" appears in it so that the latter
755 # comes immediately after the former, and change "pick" to
756 # "fixup"/"squash".
757 #
758 # Note that if the config has specified a custom instruction format
759 # each log message will be re-retrieved in order to normalize the
760 # autosquash arrangement
761 rearrange_squash () {
762 # extract fixup!/squash! lines and resolve any referenced sha1's
763 while read -r pick sha1 message
764 do
765 test -z "${format}" || message=$(git log -n 1 --format="%s" ${sha1})
766 case "$message" in
767 "squash! "*|"fixup! "*)
768 action="${message%%!*}"
769 rest=$message
770 prefix=
771 # skip all squash! or fixup! (but save for later)
772 while :
773 do
774 case "$rest" in
775 "squash! "*|"fixup! "*)
776 prefix="$prefix${rest%%!*},"
777 rest="${rest#*! }"
778 ;;
779 *)
780 break
781 ;;
782 esac
783 done
784 printf '%s %s %s %s\n' "$sha1" "$action" "$prefix" "$rest"
785 # if it's a single word, try to resolve to a full sha1 and
786 # emit a second copy. This allows us to match on both message
787 # and on sha1 prefix
788 if test "${rest#* }" = "$rest"; then
789 fullsha="$(git rev-parse -q --verify "$rest" 2>/dev/null)"
790 if test -n "$fullsha"; then
791 # prefix the action to uniquely identify this line as
792 # intended for full sha1 match
793 echo "$sha1 +$action $prefix $fullsha"
794 fi
795 fi
796 esac
797 done >"$1.sq" <"$1"
798 test -s "$1.sq" || return
799
800 used=
801 while read -r pick sha1 message
802 do
803 case " $used" in
804 *" $sha1 "*) continue ;;
805 esac
806 printf '%s\n' "$pick $sha1 $message"
807 test -z "${format}" || message=$(git log -n 1 --format="%s" ${sha1})
808 used="$used$sha1 "
809 while read -r squash action msg_prefix msg_content
810 do
811 case " $used" in
812 *" $squash "*) continue ;;
813 esac
814 emit=0
815 case "$action" in
816 +*)
817 action="${action#+}"
818 # full sha1 prefix test
819 case "$msg_content" in "$sha1"*) emit=1;; esac ;;
820 *)
821 # message prefix test
822 case "$message" in "$msg_content"*) emit=1;; esac ;;
823 esac
824 if test $emit = 1; then
825 if test -n "${format}"
826 then
827 msg_content=$(git log -n 1 --format="${format}" ${squash})
828 else
829 msg_content="$(echo "$msg_prefix" | sed "s/,/! /g")$msg_content"
830 fi
831 printf '%s\n' "$action $squash $msg_content"
832 used="$used$squash "
833 fi
834 done <"$1.sq"
835 done >"$1.rearranged" <"$1"
836 cat "$1.rearranged" >"$1"
837 rm -f "$1.sq" "$1.rearranged"
838 }
839
840 # Add commands after a pick or after a squash/fixup serie
841 # in the todo list.
842 add_exec_commands () {
843 {
844 first=t
845 while read -r insn rest
846 do
847 case $insn in
848 pick)
849 test -n "$first" ||
850 printf "%s" "$cmd"
851 ;;
852 esac
853 printf "%s %s\n" "$insn" "$rest"
854 first=
855 done
856 printf "%s" "$cmd"
857 } <"$1" >"$1.new" &&
858 mv "$1.new" "$1"
859 }
860
861 # Check if the SHA-1 passed as an argument is a
862 # correct one, if not then print $2 in "$todo".badsha
863 # $1: the SHA-1 to test
864 # $2: the line number of the input
865 # $3: the input filename
866 check_commit_sha () {
867 badsha=0
868 if test -z $1
869 then
870 badsha=1
871 else
872 sha1_verif="$(git rev-parse --verify --quiet $1^{commit})"
873 if test -z $sha1_verif
874 then
875 badsha=1
876 fi
877 fi
878
879 if test $badsha -ne 0
880 then
881 line="$(sed -n -e "${2}p" "$3")"
882 warn "Warning: the SHA-1 is missing or isn't" \
883 "a commit in the following line:"
884 warn " - $line"
885 warn
886 fi
887
888 return $badsha
889 }
890
891 # prints the bad commits and bad commands
892 # from the todolist in stdin
893 check_bad_cmd_and_sha () {
894 retval=0
895 lineno=0
896 while read -r command rest
897 do
898 lineno=$(( $lineno + 1 ))
899 case $command in
900 "$comment_char"*|''|noop|x|exec)
901 # Doesn't expect a SHA-1
902 ;;
903 "$cr")
904 # Work around CR left by "read" (e.g. with Git for
905 # Windows' Bash).
906 ;;
907 pick|p|drop|d|reword|r|edit|e|squash|s|fixup|f)
908 if ! check_commit_sha "${rest%%[ ]*}" "$lineno" "$1"
909 then
910 retval=1
911 fi
912 ;;
913 *)
914 line="$(sed -n -e "${lineno}p" "$1")"
915 warn "Warning: the command isn't recognized" \
916 "in the following line:"
917 warn " - $line"
918 warn
919 retval=1
920 ;;
921 esac
922 done <"$1"
923 return $retval
924 }
925
926 # Print the list of the SHA-1 of the commits
927 # from stdin to stdout
928 todo_list_to_sha_list () {
929 git stripspace --strip-comments |
930 while read -r command sha1 rest
931 do
932 case $command in
933 "$comment_char"*|''|noop|x|"exec")
934 ;;
935 *)
936 long_sha=$(git rev-list --no-walk "$sha1" 2>/dev/null)
937 printf "%s\n" "$long_sha"
938 ;;
939 esac
940 done
941 }
942
943 # Use warn for each line in stdin
944 warn_lines () {
945 while read -r line
946 do
947 warn " - $line"
948 done
949 }
950
951 # Switch to the branch in $into and notify it in the reflog
952 checkout_onto () {
953 GIT_REFLOG_ACTION="$GIT_REFLOG_ACTION: checkout $onto_name"
954 output git checkout $onto || die_abort "could not detach HEAD"
955 git update-ref ORIG_HEAD $orig_head
956 }
957
958 get_missing_commit_check_level () {
959 check_level=$(git config --get rebase.missingCommitsCheck)
960 check_level=${check_level:-ignore}
961 # Don't be case sensitive
962 printf '%s' "$check_level" | tr 'A-Z' 'a-z'
963 }
964
965 # Check if the user dropped some commits by mistake
966 # Behaviour determined by rebase.missingCommitsCheck.
967 # Check if there is an unrecognized command or a
968 # bad SHA-1 in a command.
969 check_todo_list () {
970 raise_error=f
971
972 check_level=$(get_missing_commit_check_level)
973
974 case "$check_level" in
975 warn|error)
976 # Get the SHA-1 of the commits
977 todo_list_to_sha_list <"$todo".backup >"$todo".oldsha1
978 todo_list_to_sha_list <"$todo" >"$todo".newsha1
979
980 # Sort the SHA-1 and compare them
981 sort -u "$todo".oldsha1 >"$todo".oldsha1+
982 mv "$todo".oldsha1+ "$todo".oldsha1
983 sort -u "$todo".newsha1 >"$todo".newsha1+
984 mv "$todo".newsha1+ "$todo".newsha1
985 comm -2 -3 "$todo".oldsha1 "$todo".newsha1 >"$todo".miss
986
987 # Warn about missing commits
988 if test -s "$todo".miss
989 then
990 test "$check_level" = error && raise_error=t
991
992 warn "Warning: some commits may have been dropped" \
993 "accidentally."
994 warn "Dropped commits (newer to older):"
995
996 # Make the list user-friendly and display
997 opt="--no-walk=sorted --format=oneline --abbrev-commit --stdin"
998 git rev-list $opt <"$todo".miss | warn_lines
999
1000 warn "To avoid this message, use \"drop\" to" \
1001 "explicitly remove a commit."
1002 warn
1003 warn "Use 'git config rebase.missingCommitsCheck' to change" \
1004 "the level of warnings."
1005 warn "The possible behaviours are: ignore, warn, error."
1006 warn
1007 fi
1008 ;;
1009 ignore)
1010 ;;
1011 *)
1012 warn "Unrecognized setting $check_level for option" \
1013 "rebase.missingCommitsCheck. Ignoring."
1014 ;;
1015 esac
1016
1017 if ! check_bad_cmd_and_sha "$todo"
1018 then
1019 raise_error=t
1020 fi
1021
1022 if test $raise_error = t
1023 then
1024 # Checkout before the first commit of the
1025 # rebase: this way git rebase --continue
1026 # will work correctly as it expects HEAD to be
1027 # placed before the commit of the next action
1028 checkout_onto
1029
1030 warn "You can fix this with 'git rebase --edit-todo'."
1031 die "Or you can abort the rebase with 'git rebase --abort'."
1032 fi
1033 }
1034
1035 # The whole contents of this file is run by dot-sourcing it from
1036 # inside a shell function. It used to be that "return"s we see
1037 # below were not inside any function, and expected to return
1038 # to the function that dot-sourced us.
1039 #
1040 # However, FreeBSD /bin/sh misbehaves on such a construct and
1041 # continues to run the statements that follow such a "return".
1042 # As a work-around, we introduce an extra layer of a function
1043 # here, and immediately call it after defining it.
1044 git_rebase__interactive () {
1045
1046 case "$action" in
1047 continue)
1048 # do we have anything to commit?
1049 if git diff-index --cached --quiet HEAD --
1050 then
1051 # Nothing to commit -- skip this commit
1052
1053 test ! -f "$GIT_DIR"/CHERRY_PICK_HEAD ||
1054 rm "$GIT_DIR"/CHERRY_PICK_HEAD ||
1055 die "Could not remove CHERRY_PICK_HEAD"
1056 else
1057 if ! test -f "$author_script"
1058 then
1059 gpg_sign_opt_quoted=${gpg_sign_opt:+$(git rev-parse --sq-quote "$gpg_sign_opt")}
1060 die "You have staged changes in your working tree. If these changes are meant to be
1061 squashed into the previous commit, run:
1062
1063 git commit --amend $gpg_sign_opt_quoted
1064
1065 If they are meant to go into a new commit, run:
1066
1067 git commit $gpg_sign_opt_quoted
1068
1069 In both case, once you're done, continue with:
1070
1071 git rebase --continue
1072 "
1073 fi
1074 . "$author_script" ||
1075 die "Error trying to find the author identity to amend commit"
1076 if test -f "$amend"
1077 then
1078 current_head=$(git rev-parse --verify HEAD)
1079 test "$current_head" = $(cat "$amend") ||
1080 die "\
1081 You have uncommitted changes in your working tree. Please, commit them
1082 first and then run 'git rebase --continue' again."
1083 do_with_author git commit --amend --no-verify -F "$msg" -e \
1084 ${gpg_sign_opt:+"$gpg_sign_opt"} ||
1085 die "Could not commit staged changes."
1086 else
1087 do_with_author git commit --no-verify -F "$msg" -e \
1088 ${gpg_sign_opt:+"$gpg_sign_opt"} ||
1089 die "Could not commit staged changes."
1090 fi
1091 fi
1092
1093 if test -r "$state_dir"/stopped-sha
1094 then
1095 record_in_rewritten "$(cat "$state_dir"/stopped-sha)"
1096 fi
1097
1098 require_clean_work_tree "rebase"
1099 do_rest
1100 return 0
1101 ;;
1102 skip)
1103 git rerere clear
1104
1105 do_rest
1106 return 0
1107 ;;
1108 edit-todo)
1109 git stripspace --strip-comments <"$todo" >"$todo".new
1110 mv -f "$todo".new "$todo"
1111 collapse_todo_ids
1112 append_todo_help
1113 git stripspace --comment-lines >>"$todo" <<\EOF
1114
1115 You are editing the todo file of an ongoing interactive rebase.
1116 To continue rebase after editing, run:
1117 git rebase --continue
1118
1119 EOF
1120
1121 git_sequence_editor "$todo" ||
1122 die "Could not execute editor"
1123 expand_todo_ids
1124
1125 exit
1126 ;;
1127 esac
1128
1129 git var GIT_COMMITTER_IDENT >/dev/null ||
1130 die "You need to set your committer info first"
1131
1132 comment_for_reflog start
1133
1134 if test ! -z "$switch_to"
1135 then
1136 GIT_REFLOG_ACTION="$GIT_REFLOG_ACTION: checkout $switch_to"
1137 output git checkout "$switch_to" -- ||
1138 die "Could not checkout $switch_to"
1139
1140 comment_for_reflog start
1141 fi
1142
1143 orig_head=$(git rev-parse --verify HEAD) || die "No HEAD?"
1144 mkdir -p "$state_dir" || die "Could not create temporary $state_dir"
1145
1146 : > "$state_dir"/interactive || die "Could not mark as interactive"
1147 write_basic_state
1148 if test t = "$preserve_merges"
1149 then
1150 if test -z "$rebase_root"
1151 then
1152 mkdir "$rewritten" &&
1153 for c in $(git merge-base --all $orig_head $upstream)
1154 do
1155 echo $onto > "$rewritten"/$c ||
1156 die "Could not init rewritten commits"
1157 done
1158 else
1159 mkdir "$rewritten" &&
1160 echo $onto > "$rewritten"/root ||
1161 die "Could not init rewritten commits"
1162 fi
1163 # No cherry-pick because our first pass is to determine
1164 # parents to rewrite and skipping dropped commits would
1165 # prematurely end our probe
1166 merges_option=
1167 else
1168 merges_option="--no-merges --cherry-pick"
1169 fi
1170
1171 shorthead=$(git rev-parse --short $orig_head)
1172 shortonto=$(git rev-parse --short $onto)
1173 if test -z "$rebase_root"
1174 # this is now equivalent to ! -z "$upstream"
1175 then
1176 shortupstream=$(git rev-parse --short $upstream)
1177 revisions=$upstream...$orig_head
1178 shortrevisions=$shortupstream..$shorthead
1179 else
1180 revisions=$onto...$orig_head
1181 shortrevisions=$shorthead
1182 fi
1183 format=$(git config --get rebase.instructionFormat)
1184 # the 'rev-list .. | sed' requires %m to parse; the instruction requires %H to parse
1185 git rev-list $merges_option --format="%m%H ${format:-%s}" \
1186 --reverse --left-right --topo-order \
1187 $revisions ${restrict_revision+^$restrict_revision} | \
1188 sed -n "s/^>//p" |
1189 while read -r sha1 rest
1190 do
1191
1192 if test -z "$keep_empty" && is_empty_commit $sha1 && ! is_merge_commit $sha1
1193 then
1194 comment_out="$comment_char "
1195 else
1196 comment_out=
1197 fi
1198
1199 if test t != "$preserve_merges"
1200 then
1201 printf '%s\n' "${comment_out}pick $sha1 $rest" >>"$todo"
1202 else
1203 if test -z "$rebase_root"
1204 then
1205 preserve=t
1206 for p in $(git rev-list --parents -1 $sha1 | cut -d' ' -s -f2-)
1207 do
1208 if test -f "$rewritten"/$p
1209 then
1210 preserve=f
1211 fi
1212 done
1213 else
1214 preserve=f
1215 fi
1216 if test f = "$preserve"
1217 then
1218 touch "$rewritten"/$sha1
1219 printf '%s\n' "${comment_out}pick $sha1 $rest" >>"$todo"
1220 fi
1221 fi
1222 done
1223
1224 # Watch for commits that been dropped by --cherry-pick
1225 if test t = "$preserve_merges"
1226 then
1227 mkdir "$dropped"
1228 # Save all non-cherry-picked changes
1229 git rev-list $revisions --left-right --cherry-pick | \
1230 sed -n "s/^>//p" > "$state_dir"/not-cherry-picks
1231 # Now all commits and note which ones are missing in
1232 # not-cherry-picks and hence being dropped
1233 git rev-list $revisions |
1234 while read rev
1235 do
1236 if test -f "$rewritten"/$rev && test "$(sane_grep "$rev" "$state_dir"/not-cherry-picks)" = ""
1237 then
1238 # Use -f2 because if rev-list is telling us this commit is
1239 # not worthwhile, we don't want to track its multiple heads,
1240 # just the history of its first-parent for others that will
1241 # be rebasing on top of it
1242 git rev-list --parents -1 $rev | cut -d' ' -s -f2 > "$dropped"/$rev
1243 sha1=$(git rev-list -1 $rev)
1244 sane_grep -v "^[a-z][a-z]* $sha1" <"$todo" > "${todo}2" ; mv "${todo}2" "$todo"
1245 rm "$rewritten"/$rev
1246 fi
1247 done
1248 fi
1249
1250 test -s "$todo" || echo noop >> "$todo"
1251 test -n "$autosquash" && rearrange_squash "$todo"
1252 test -n "$cmd" && add_exec_commands "$todo"
1253
1254 todocount=$(git stripspace --strip-comments <"$todo" | wc -l)
1255 todocount=${todocount##* }
1256
1257 cat >>"$todo" <<EOF
1258
1259 $comment_char Rebase $shortrevisions onto $shortonto ($todocount command(s))
1260 EOF
1261 append_todo_help
1262 git stripspace --comment-lines >>"$todo" <<\EOF
1263
1264 However, if you remove everything, the rebase will be aborted.
1265
1266 EOF
1267
1268 if test -z "$keep_empty"
1269 then
1270 printf '%s\n' "$comment_char Note that empty commits are commented out" >>"$todo"
1271 fi
1272
1273
1274 has_action "$todo" ||
1275 return 2
1276
1277 cp "$todo" "$todo".backup
1278 collapse_todo_ids
1279 git_sequence_editor "$todo" ||
1280 die_abort "Could not execute editor"
1281
1282 has_action "$todo" ||
1283 return 2
1284
1285 check_todo_list
1286
1287 expand_todo_ids
1288
1289 test -d "$rewritten" || test -n "$force_rebase" || skip_unnecessary_picks
1290
1291 checkout_onto
1292 do_rest
1293
1294 }
1295 # ... and then we call the whole thing.
1296 git_rebase__interactive